#ifndef _TARGET_SENSE_H
#define _TARGET_SENSE_H


//------------------------------------
// target_sense.h
//
// 'Defines' and variables specific to coil setup
//
//
// Modified 24-April-2024
//
//------------------------------------

// Points on the sample array and where they are in time.
// Fixed by the sample speed. Never change these indexes
//
#define INDEX_12uSEC (4)
#define INDEX_15uSEC (5)
#define INDEX_18uSEC (6)
#define INDEX_21uSEC (7)
#define INDEX_24uSEC (8)
#define INDEX_27uSEC (9)
#define INDEX_30uSEC (10)
#define INDEX_33uSEC (11)
#define INDEX_36uSEC (12)
#define INDEX_39uSEC (13)
#define INDEX_42uSEC (14)
#define INDEX_45uSEC (15)
#define INDEX_48uSEC (16)
#define INDEX_51uSEC (17)
#define INDEX_54uSEC (18)
#define INDEX_57uSEC (19)
#define INDEX_60uSEC (20)
#define INDEX_63uSEC (21)
#define INDEX_66uSEC (22)
#define INDEX_69uSEC (23)
#define INDEX_72uSEC (24)
#define INDEX_75uSEC (25)
#define INDEX_78uSEC (26)
#define INDEX_81uSEC (27)
#define INDEX_84uSEC (28)
#define INDEX_88uSEC (29)


#define R1 (0)
#define R2 (1)
#define R3 (2)
#define R4 (3)

// samples on the discharge curve
//
#define TIME_POINTS (5)


void normalise(double arr[], int sz);
bool isTarget_Set1(double sig_curve[]);
bool isIron_Set1(double sig_curve[], bool printOut );
void targetID_Set1(double sig_curve[], bool printOut);

//
enum TARGETID{OK_BIG, OK_SMALL, Fe, NO_TARGET};

class TARGET_SENSE{

  public:
    static TARGETID targetID;          
};

TARGETID TARGET_SENSE::targetID;

// PULSE WIDTHS
//
#define PULSE_15uSEC (90)
#define PULSE_20uSEC (120)
#define PULSE_30uSEC (180)
#define PULSE_40uSEC (240)
#define PULSE_60uSEC (360)
#define PULSE_70uSEC (420)
#define PULSE_80uSEC (480)
#define PULSE_90uSEC (540)



//------------------------   COIL SELECTION uncomment block depending on coil --------------------------------
//
// SAMPLE_INDEXES sets What samples are we interested in from the raw samples 
// SOUND_INDEX is the particular sample from SAMPLE_INDEXES that changes the sound frequency and volume
// THRESHOLD is used by target ID
// PULSE_WIDTH is the pulse width
//





//------ 20cm coil ------------------------------------------------------------
#include "coil_20cm.h"

//----- 13cn (5 inch) coil -------------------------------------------------
//#include "coil_highspeed1.h"




#endif
// _TARGET_SENSE_H